gcc_release (announce_snapshot): Add substitution of @RELEASE@ for README and index...
[gcc.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File: gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date: 2001-05-25
8 #
9 # Contents:
10 # Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 # gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53 echo "gcc_release: error: $1"
54 exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60 echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [further options]
68 gcc_release -s [further options]
69
70 Options:
71
72 -r release Version of the form X.Y or X.Y.Z.
73 -s Create a snapshot, not a real release.
74
75 -d destination Local working directory where we will build the release
76 (default=${HOME}).
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
82 EOF
83 exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89 cd $1 || \
90 error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree. Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98 for x in $@; do
99 echo `basename ${SOURCE_DIRECTORY}`/$x
100 done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error "\`${WORKING_DIRECTORY}' already exists"
110 fi
111 # Create the WORKING_DIRECTORY.
112 mkdir "${WORKING_DIRECTORY}" \
113 || error "Could not create \`${WORKING_DIRECTORY}'"
114 changedir "${WORKING_DIRECTORY}"
115
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform "Updating ChangeLogs and version files"
120
121 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122 -r ${CVSBRANCH} gcc || \
123 error "Could not check out release sources"
124 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125 # Update this ChangeLog file only if it does not yet contain the
126 # entry we are going to add. (This is a safety net for repeated
127 # runs of this script for the same release.)
128 if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then
129 cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE} Release Manager
131
132 * GCC ${RELEASE} released.
133
134 EOF
135 mv ${x}.new ${x} || \
136 error "Could not update ${x}"
137 (changedir `dirname ${x}` && \
138 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139 error "Could not commit ${x}"
140 fi
141 done
142
143 # Update `gcc/version.c'.
144 for x in gcc/version.c; do
145 y=`basename ${x}`
146 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147 sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148 mv ${y}.new ${y} && \
149 ${CVS} ci -m 'Update version' ${y}) || \
150 error "Could not update ${x}"
151 done
152
153 # Make sure we tag the sources for a final release.
154 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156 rm -rf ${SOURCE_DIRECTORY}
157 fi
158
159 # Tag the sources.
160 if [ -n "${TAG}" ]; then
161 inform "Tagging sources as ${TAG}"
162 ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
163 error "Could not tag sources"
164 CVSBRANCH=$TAG
165 fi
166
167 # Export the current sources.
168 inform "Retrieving release sources"
169 ${CVS} \
170 export -d "`basename ${SOURCE_DIRECTORY}`" \
171 -r ${CVSBRANCH} gcc || \
172 error "Could not retrieve release sources"
173
174 # Run gcc_update on them to set up the timestamps nicely.
175 changedir "gcc-${RELEASE}"
176 contrib/gcc_update --touch
177
178 # Obtain some documentation files from the wwwdocs module.
179 inform "Retrieving HTML documentation"
180 changedir "${WORKING_DIRECTORY}"
181 for x in bugs faq; do
182 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
183 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
184 ${SOURCE_DIRECTORY}) || \
185 error "Could not retrieve ${x}.html"
186 done
187
188 inform "Generating plain-text documentation from HTML"
189 changedir "${SOURCE_DIRECTORY}"
190 for file in *.html; do
191 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
192 (${ENV} TERM=vt100 lynx -dump $file \
193 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
194 > $newfile) || \
195 error "Could not generate text-only version of ${file}"
196 done
197
198 # For a prerelease or real release, we need to generate additional
199 # files not present in CVS.
200 changedir "${SOURCE_DIRECTORY}"
201 if [ $SNAPSHOT -ne 1 ]; then
202 # Generate the documentation.
203 inform "Building install docs"
204 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
205 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
206 export SOURCEDIR
207 export DESTDIR
208 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
209
210 # Regenerate the NEWS file.
211 contrib/gennews > gcc/NEWS || \
212 error "Could not regenerate NEWS files"
213
214 # Now, we must build the compiler in order to create any generated
215 # files that are supposed to go in the source directory. This is
216 # also a good sanity check to make sure that the release builds
217 # on at least one platform.
218 inform "Building compiler"
219 OBJECT_DIRECTORY=../objdir
220 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
221 error "Could not rebuild GCC"
222
223 # Regenerate the Fotran NEWS and BUGS files.
224 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
225 error "Could not regenerate Fortran NEWS and BUGS files"
226 fi
227
228 # Move message catalogs to source directory.
229 mv ../objdir/gcc/po/*.gmo gcc/po/
230
231 # Create a `.brik' file to use for checking the validity of the
232 # release.
233 changedir "${SOURCE_DIRECTORY}"
234 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
235 ((find . -type f | sort > $BRIK_FILE) && \
236 brik -Gb -f ${BRIK_FILE} > .brik && \
237 rm ${BRIK_FILE}) || \
238 error "Could not compute brik checksum"
239 }
240
241 # Buid a single tarfile. The first argument is the name of the name
242 # of the tarfile to build, without any suffixes. They will be added
243 # automatically. The rest of the arguments are the files or
244 # directories to include.
245
246 build_tarfile() {
247 # Get the name of the destination tar file.
248 TARFILE="$1.tar.bz2"
249 shift
250
251 # Build the tar file itself.
252 (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
253 error "Could not build tarfile"
254 FILE_LIST="${FILE_LIST} ${TARFILE}"
255 }
256
257 # Build the various tar files for the release.
258
259 build_tarfiles() {
260 inform "Building tarfiles"
261
262 changedir "${WORKING_DIRECTORY}"
263
264 # The GNU Coding Standards specify that all files should
265 # world readable.
266 chmod -R a+r ${SOURCE_DIRECTORY}
267 # And that all directories have mode 777.
268 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
269
270 # Build one huge tarfile for the entire distribution.
271 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
272
273 # Now, build one for each of the languages.
274 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
275 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
276 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
277 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
278 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
279 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
280
281 # The core is everything else.
282 EXCLUDES=""
283 for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
284 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
285 EXCLUDES="${EXCLUDES} --exclude $x"
286 done
287 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
288 `basename ${SOURCE_DIRECTORY}`
289 }
290
291 # Build .gz files.
292 build_gzip() {
293 for f in ${FILE_LIST}; do
294 target=${f%.bz2}.gz
295 (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
296 done
297 }
298
299 # Build diffs against an old release.
300 build_diffs() {
301 old_dir=${1%/*}
302 old_file=${1##*/}
303 old_vers=${old_file%.tar.bz2}
304 old_vers=${old_vers#gcc-}
305 inform "Building diffs against version $old_vers"
306 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
307 old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
308 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
309 if [ ! -e $old_tar ]; then
310 inform "$old_tar not found; not generating diff file"
311 elif [ ! -e $new_tar ]; then
312 inform "$new_tar not found; not generating diff file"
313 else
314 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
315 ${f}-${old_vers}-${RELEASE}.diff.bz2
316 fi
317 done
318 }
319
320 # Build an individual diff.
321 build_diff() {
322 changedir "${WORKING_DIRECTORY}"
323 tmpdir=gccdiff.$$
324 mkdir $tmpdir || error "Could not create directory $tmpdir"
325 changedir $tmpdir
326 (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
327 (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
328 ${DIFF} $2 $4 > ../${5%.bz2}
329 if [ $? -eq 2 ]; then
330 error "Trouble making diffs from $1 to $3"
331 fi
332 ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
333 changedir ..
334 rm -rf $tmpdir
335 FILE_LIST="${FILE_LIST} $5"
336 }
337
338 # Upload the files to the FTP server.
339 upload_files() {
340 inform "Uploading files"
341
342 changedir "${WORKING_DIRECTORY}"
343
344 # Make sure the directory exists on the server.
345 if [ $LOCAL -eq 0 ]; then
346 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
347 mkdir -p "${FTP_PATH}/diffs"
348 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
349 else
350 mkdir -p "${FTP_PATH}/diffs" \
351 || error "Could not create \`${FTP_PATH}'"
352 UPLOAD_PATH=${FTP_PATH}
353 fi
354
355 # Then copy files to their respective (sub)directories.
356 for x in gcc*.gz gcc*.bz2; do
357 if [ -e ${x} ]; then
358 # Make sure the file will be readable on the server.
359 chmod a+r ${x}
360 # Copy it.
361 case ${x} in
362 *.diff.*)
363 SUBDIR="diffs/";
364 ;;
365 *)
366 SUBDIR="";
367 esac
368 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
369 || error "Could not upload ${x}"
370 fi
371 done
372 }
373
374 # Announce a snapshot, both on the web and via mail.
375 announce_snapshot() {
376 inform "Updating links and READMEs on the FTP server"
377
378 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
379 cd ~ftp/pub/gcc/snapshots
380 sed -e "s%@DATE@%$DATE%g" \
381 -e "s%@LAST_DATE@%$LAST_DATE%g" \
382 -e "s%@BRANCH@%${BRANCH}%g" \
383 -e "s%@RELEASE@%${RELEASE}%g" \
384 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
385 mv $$ README
386 sed -e "s%@DATE@%$DATE%g" \
387 -e "s%@LAST_DATE@%$LAST_DATE%g" \
388 -e "s%@BRANCH@%${BRANCH}%g" \
389 -e "s%@RELEASE@%${RELEASE}%g" \
390 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
391 mv $$ ${BRANCH}-${DATE}/index.html
392
393 touch LATEST-IS-${BRANCH}-${DATE}
394 rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
395
396 inform "Sending mail"
397
398 export QMAILHOST=gcc.gnu.org
399 mail -s "gcc-ss-${BRANCH}-${DATE} is now available" gccadmin@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
400 }
401
402 ########################################################################
403 # Initialization
404 ########################################################################
405
406 # Today's date.
407 DATE=`date "+%Y%m%d"`
408 LONG_DATE=`date "+%Y-%m-%d"`
409
410 # The CVS server containing the GCC repository.
411 CVS_SERVER="gcc.gnu.org"
412 # The path to the repository on that server.
413 CVS_REPOSITORY="/cvs/gcc"
414 # The CVS protocol to use.
415 CVS_PROTOCOL="ext"
416 # The username to use when connecting to the server.
417 CVS_USERNAME="${USER}"
418
419 # The machine to which files will be uploaded.
420 GCC_HOSTNAME="gcc.gnu.org"
421 # The name of the account on the machine to which files are uploaded.
422 GCC_USERNAME="gccadmin"
423 # The directory in which the files will be placed.
424 FTP_PATH="~ftp/pub/gcc"
425
426 # The major number for the release. For release `3.0.2' this would be
427 # `3'
428 RELEASE_MAJOR=""
429 # The minor number for the release. For release `3.0.2' this would be
430 # `0'.
431 RELEASE_MINOR=""
432 # The revision number for the release. For release `3.0.2' this would
433 # be `2'.
434 RELEASE_REVISION=""
435 # The complete name of the release.
436 RELEASE=""
437
438 # The name of the branch from which the release should be made, in a
439 # user-friendly form.
440 BRANCH=""
441
442 # The name of the branch from which the release should be made, as used
443 # for our version control system.
444 CVSBRANCH=""
445
446 # The tag to apply to the sources used for the release.
447 TAG=""
448
449 # The old tarballs from which to generate diffs.
450 OLD_TARS=""
451
452 # The directory that will be used to construct the release. The
453 # release itself will be placed in a subdirectory of this diretory.
454 DESTINATION=${HOME}
455 # The subdirectory.
456 WORKING_DIRECTORY=""
457 # The directory that will contain the GCC sources.
458 SOURCE_DIRECTORY=""
459
460 # The directories that should be part of the various language-specific
461 # tar files. These are all relative to the top of the source tree.
462 ADA_DIRS="gcc/ada"
463 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
464 FORTRAN_DIRS="gcc/f libf2c"
465 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
466 OBJECTIVEC_DIRS="gcc/objc libobjc"
467 TESTSUITE_DIRS="gcc/testsuite"
468
469 # Non-zero if this is the final release, rather than a prerelease.
470 FINAL=0
471
472 # Non-zero if we are building a snapshot, and don't build gcc or
473 # include generated files.
474 SNAPSHOT=0
475
476 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
477 # and copy directly to the FTP directory.
478 LOCAL=0
479
480 # Major operation modes.
481 MODE_GZIP=0
482 MODE_DIFFS=0
483 MODE_SOURCES=0
484 MODE_TARFILES=0
485 MODE_UPLOAD=0
486
487 # List of archive files generated; used to create .gz files from .bz2.
488 FILE_LIST=""
489
490 # Programs we use.
491
492 BZIP2="${BZIP2:-bzip2}"
493 CVS="${CVS:-cvs -f -Q -z9}"
494 DIFF="${DIFF:-diff -Nrc3pad}"
495 ENV="${ENV:-env}"
496 GZIP="${GZIP:-gzip --best}"
497 SCP="${SCP:-scp -p}"
498 SSH="${SSH:-ssh}"
499 TAR="${TAR:-tar}"
500
501 ########################################################################
502 # Command Line Processing
503 ########################################################################
504
505 # Parse the options.
506 while getopts "d:fr:u:t:p:sl" ARG; do
507 case $ARG in
508 d) DESTINATION="${OPTARG}";;
509 r) RELEASE="${OPTARG}";;
510 t) TAG="${OPTARG}";;
511 u) CVS_USERNAME="${OPTARG}";;
512 f) FINAL=1;;
513 s) SNAPSHOT=1;;
514 l) LOCAL=1
515 SCP=cp
516 FTP_PATH=~ftp/pub/gcc
517 PATH=~:/usr/local/bin:$PATH;;
518 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
519 if [ -d ${OPTARG} ]; then
520 error "-p argument must name a tarball"
521 fi;;
522 \?) usage;;
523 esac
524 done
525 shift `expr ${OPTIND} - 1`
526
527 # Handle the major modes.
528 while [ $# -ne 0 ]; do
529 case $1 in
530 diffs) MODE_DIFFS=1;;
531 gzip) MODE_GZIP=1;;
532 sources) MODE_SOURCES=1;;
533 tarfiles) MODE_TARFILES=1;;
534 upload) MODE_UPLOAD=1;;
535 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
536 if [ $SNAPSHOT -ne 1 ]; then
537 # Only for releases and pre-releases.
538 MODE_GZIP=1;
539 fi
540 ;;
541 *) error "Unknown mode $1";;
542 esac
543 shift
544 done
545
546 # Perform consistency checking.
547 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
548 error "No username specified"
549 fi
550
551 if [ ! -d ${DESTINATION} ]; then
552 error "\`${DESTINATION}' is not a directory"
553 fi
554
555 if [ $SNAPSHOT -eq 0 ]; then
556 if [ -z ${RELEASE} ]; then
557 error "No release number specified"
558 fi
559
560 # Compute the major and minor release numbers.
561 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
562 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
563 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
564
565 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
566 error "Release number \`${RELEASE}' is invalid"
567 fi
568
569 # Compute the full name of the release.
570 if [ -z "${RELEASE_REVISION}" ]; then
571 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
572 else
573 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
574 fi
575
576 # Compute the name of the branch, which is based solely on the major
577 # and minor release numbers.
578 CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
579
580 # If this is not a final release, set various parameters acordingly.
581 if [ ${FINAL} -ne 1 ]; then
582 RELEASE="${RELEASE}-${DATE}"
583 FTP_PATH="${FTP_PATH}/snapshots/"
584 else
585 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
586 fi
587 else
588 RELEASE=$DATE
589 # For now snapshots come from the 3.3 branch.
590 BRANCH="3.3"
591 CVSBRANCH=gcc-3_3-branch
592 FTP_PATH="${FTP_PATH}/snapshots/${BRANCH}-${DATE}"
593 TAG=gcc-ss-`echo ${BRANCH} | tr '.' '_'`-${DATE}
594
595 # Building locally on gcc.gnu.org, we know what the last snapshot date
596 # was.
597 if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ]; then
598 LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
599 LAST_DIR=~ftp/pub/gcc/snapshots/${BRANCH}-${LAST_DATE}
600 OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.bz2
601 fi
602 fi
603
604 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
605 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
606 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
607
608 # Recompute the names of all the language-specific directories,
609 # relative to the WORKING_DIRECTORY.
610 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
611 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
612 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
613 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
614 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
615 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
616
617 # Set up CVSROOT.
618 if [ $LOCAL -eq 0 ]; then
619 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
620 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
621 else
622 CVSROOT="${CVS_REPOSITORY}"
623 fi
624 export CVSROOT
625
626 ########################################################################
627 # Main Program
628 ########################################################################
629
630 # Set the timezone to UTC
631 TZ="UTC0"
632 export TZ
633
634 # Build the source directory.
635
636 if [ $MODE_SOURCES -ne 0 ]; then
637 build_sources
638 fi
639
640 # Build the tar files.
641
642 if [ $MODE_TARFILES -ne 0 ]; then
643 build_tarfiles
644 fi
645
646 # Build diffs
647
648 if [ $MODE_DIFFS -ne 0 ]; then
649 # Possibly build diffs.
650 if [ -n "$OLD_TARS" ]; then
651 for old_tar in $OLD_TARS; do
652 build_diffs $old_tar
653 done
654 fi
655 fi
656
657 # Build gzip files
658 if [ $MODE_GZIP -ne 0 ]; then
659 build_gzip
660 fi
661
662 # Upload them to the FTP server.
663
664 if [ $MODE_UPLOAD -ne 0 ]; then
665 upload_files
666
667 # For snapshots, make some further updates.
668 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
669 announce_snapshot
670
671 # Update snapshot date file.
672 changedir ~
673 echo $DATE > .snapshot_date-${BRANCH}
674
675 # Remove working directory
676 rm -rf ${WORKING_DIRECTORY}
677 fi
678 fi